Subject: Re: [Bitcoin-development] Bitcoin TX fill-or-kill deterministic behavior

From: Andreas Schildbach <[email-masked]>
Date: Sun, 15 Apr 2012 10:12:37 +0200

On 04/14/2012 10:20 PM, Jeff Garzik wrote:

>>> Furthermore, many of these ideas -- like sending TX's directly to the
>>> merchant -- involve far more direct payee<->payer communication on the
>>> part of the wallet client than is currently envisioned
>>
>> Yes, though it's worth remembering that the original Bitcoin design
>> did have participants communicate directly. When I talked with Satoshi
>> in 2009 he saw the pay-to-IP-address mode imagined as the normal way
>> to make payments, with pay-to-address being used as a kind of backup
>> for when the recipient was offline.
>>
>> In the end that's not how things evolved, but it the pendulum could
>> easily swing back the other way.
> 
> IIRC pay-to-IP was removed because it was unreliable -and- detrimental
> to privacy?  ISTR Satoshi specifically disliking the privacy elements
> of p2ip.
> 
> But I also have a "gut feeling" that these sorts of payments and
> direct communication should be done via a wholly separate protocol
> than the bitcoin P2P protocol.  Doing p2ip as it was done originally,
> inside the bitcoin P2P protocol, was a mistake.  Extensible as it is,
> I think a better job -- and faster evolution -- can be done with a
> separate protocol on a separate port.

Just to let you know, Bitcoin Wallet for Android already supports
directly sending transactions via NFC and QR-Code. Currently, receiving
such a transaction is handled the same way as if it was received via P2P.

This means the sender does not need to have internet access the moment
he pays. The transaction is being broadcast into the P2P network by the
receiver.

Cheers,

Andreas